# encoding: utf-8
import json
import time

import requests

url = "http://127.0.0.1:8111/title_to_video"
body = {
    "accountName": "音药养心馆",
    "content": "冲突在巴以地区再度爆发，无情地夺走了许多无辜平民的生命，给他们带来了极大的痛苦与绝望。随着这场冲突的持续加剧，死亡和受伤的人数正以令人震惊的速度上升。\n\n根据最新的数据统计，这场冲突已经导致超过12300人遇难，其中在加沙地区的死亡人数已经上升至10812人，这个数字中还包含了4412名无辜的儿童。在以色列，也有超过1400人失去了生命。这背后，是无数被破坏的家庭和被夺走的未来。\n\n随着哈驨组织加大了对以色列军方的攻击力度，加沙地区与以色列的紧张局势进一步升级。卡桑旅对阿什杜德地区以及一个以色列军事基地发射火箭，同时在加沙与以色列国防军之间爆发了激烈的战斗，不仅造成了包括若干坦克在内的军事资产损毁，也极大地加剧了平民的生活危机。\n\n这种冲突的激化，不仅展现了哈驨对以色列采取的更为激进的战术，也反映出了加沙地带与以色列之间长期紧张关系的新高点。在这种背景下，军事基地及其周边地区的安全局势变得更加不稳定，平民的安全和生计受到严重威胁。随着冲突的持续，双方都面临着更大的人道主义挑战，国际社会对于这一地区和平的呼声也愈发迫切。\n\n以色列对加沙地带若干医疗机构的空袭，进一步加剧了该地区已经岌岌可危的医疗体系状况。众多医院因为设施严重损坏而不得不暂停服务，这对人道主义救助的工作造成了极大的困难。\n\n在这场冲突中，最让人心痛的莫过于无辜平民，特别是儿童所遭受的苦难。纳赛尔儿童医院遭受的袭击，不仅破坏了医疗设施，更有一名儿童因氧气中断而悲惨死去。另一方面，加沙地带希法医院周边地区的轰炸也造成了更多的伤亡。这些行为严重违反了国际人道主义法，引发了国际社会的广泛谴责。\n\n面对这一人道主义危机，国际社会并没有袖手旁观。美国宣布以色列同意在加沙北部实施每天四小时的“人道主义暂停”，以便让平民撤离。此外，土耳其与以色列达成协议，同意将加沙地带患有癌症的儿童转移到土耳其接受治疗。埃及也向加沙地带运送了援助物资。然而，世界卫生组织指出，尽管这些努力值得赞扬，但所提供的援助与当地居民的需求相比仍然是杯水车薪。\n\n随着冲突的持续，加沙地带面临的挑战愈发严峻。食物和水资源的短缺，医疗设施的破坏，以及居民基本生活权利的严重威胁，都需要国际社会提供更多的援助和支持。在这个关键时刻，人道主义援助不仅是对加沙地带居民的关怀，更是对人类文明的一种责任。\n\n冲突的持续不仅带来了破坏和伤痛，也对人类文明提出了挑战。我们期待相关各方能够尽快找到解决问题的有效途径，为加沙地带的重建和人道主义援助提供更多的支持。这不仅关乎那些直接受到冲突影响的人们，也关系到我们共同的未来。\n\n随着这场冲突的不断报道，希望能够唤起更多人对巴以冲突的关注，以及对和平与人道主义援助的支持。让我们共同期待和平的曙光，为那些在冲突中遭受苦难的人们带去希望和援助。",
    "cover": "http://mmbiz.qpic.cn/mmbiz_jpg/DAIqn771G5OegJt9iacR7k7Gxgs0ic6Vg0fUtxmicJzxoBWicibQciaQkhgXzsyJqnfETRibGHMwZzsCkSuVXb16xdMTg/0?from=appmsg",
    # "ghId": "gh_b15de7c99912", # ab2
    "ghId": "gh_a2901d34f75b", # ab1
    "title": "加沙地带多家医院周围地区遭空袭！巴以冲突最新消息",
    # "traceId": "search-4a246d27-740d-4581-bbd9-48eb48dfcee3-1715685085",
    # "kimi_title": "🔴紧急！加沙地带医院遭空袭，巴以冲突最新动态！🔥",
    # "videoList": [20738863]
}

a = time.time()
header = {
    "Content-Type": "application/json",
}

response = requests.post(url, json=body, headers=header, timeout=600)
b = time.time()
print(b - a)
print(json.dumps(response.json(), ensure_ascii=False, indent=4))
